/* Copyright 2009 Steven Reynolds
 *  Demonstrate advanced traits */

class Celebrity(n:String,r:Int) {
    var name = n
    var rating:Int = r
    override def toString = { name + " at " + rating }
}

trait TVStarlet {
    this: Celebrity => // specifies that self type is a Celeb
    private val washOut = " - the has been -"
    var show = "unknown"
    override def toString = super.toString + ". On " + show
    def flameOut : Unit = {
        rating = 0
        name = name + washOut
        show = "none"
    }
    def comeBack(newShow: String) : Unit = {
        rating = rating + 5
        name = name.replace(washOut,"")
        show = newShow
    }
}

object AdvancedCelebEx {
    def main(args: Array[String]) :Unit = {
        
        val paula_abdul = new Celebrity("Paula Abdul",5) with TVStarlet
        paula_abdul.show = "American Idol"
        println("paula_abdul starts as: " + paula_abdul)

        paula_abdul.flameOut
        println("paula_abdul then is:   " + paula_abdul)

        paula_abdul.comeBack("some new hit show")
        println("paula_abdul now is:    " + paula_abdul)
    }
}
