/* Copyright 2009 Steven Reynolds
 *  Use a trait like a Java interface */

class Star(n:String) {
    private val name = n
    override def toString = name
}

trait Talent   {
    def talent: String
}

object InterfaceEx {

  def makeAStar(name:String, tlnt:String) : Talent = {
    new Star(name) with Talent {
        def talent = tlnt
    }
  }

  def main(args: Array[String]) :Unit = {
    println("Showing trait as an interface")
    val bf: Talent = makeAStar("Bobby Flay","cooking")
    print("Bobby Flay's talent is " + bf.talent + "\n")
  }

}
